Request

Response

    Bids
    GET

    bids/{bidId}/line-items

    Retrieves a list of all of the specified bid’s line items.

    Resource Information

    Method and URI
    GET
    https://developer.api.autodesk.com/construction/buildingconnected/v2/bids/{bidId}/line-items
    Authentication Context
    User context required
    Required OAuth Scopes
    data:read
    Data Format
    JSON

    Request

    Headers

    Authorization*
    string
    Must be Bearer <token>, where <token> is a three-legged access token obtained via an Authorization Code flow.
    * Required

    Request

    URI Parameters

    bidId
    string
    The unique ID of the bid.

    Request

    Query String Parameters

    cursorState
    string
    An opaque cursor token that identifies where the next page of paginated results should start. It’s returned in each paginated response so that it can be provided in the next request to continue paginated results. If a paginated response contains no cursorState value, there are no further pages to return.

    Omit this parameter to initiate a paginated request or to restart pagination.

    limit
    int
    The maximum number of records that the endpoint may return per page.

    Note that a returned page may contain fewer records than the limit under either of these conditions:

    • There are fewer records found than the limit value.
    • The last page of a set is returned.

    Default value: 100

    Response

    HTTP Status Code Summary

    200
    OK
    OK
    400
    Bad Request
    The parameters of the requested operation are invalid.
    401
    Unauthorized
    The provided bearer token is not valid.
    403
    Forbidden
    The user or service represented by the bearer token does not have permission to perform this operation.
    404
    Not Found
    The requested resource could not be found.
    429
    Too Many Requests
    Rate limit exceeded; wait some time before retrying. The ‘Retry-After’ header might provide the amount of the time to wait.
    500
    Internal Server Error
    An unknown error occurred on the server.

    Response

    Body Structure (200)

    Expand all
    pagination
    object
    The pagination details of a response.
    limit
    int
    The maximum number of records to return per page.

    Note that a returned page may contain fewer records than the limit under either of these conditions:

    • There are fewer records found than the limit value.
    • The last or only page is returned.
    cursorState
    string
    An opaque cursor token that identifies where the next page of paginated results should start. It’s returned in each paginated response so that it can be provided in the next request to continue paginated results. If a paginated response contains no cursorState value, there are no further pages to return.

    Omit this parameter to initiate a paginated request or to restart pagination.

    nextUrl
    string
    The URL path that returns the next page of data.
    results
    array: object
    The details of the line items on a bid.
    id
    string
    The unique ID of the line item. This value is null if it’s the default line item.

    Max length: 24

    type
    enum:string
    The line item’s type.

    The possible values have the following UI equivalents:

    • ACKNOWLEDGMENT — General Acknowledgments
    • ADDENDUM — Scope-Specific Information and Unit Costs
    • ALTERNATE — Alternates
    • BONDING — Bond Information
    • CERTIFICATION — Certifications
    • COST_BREAKDOWN — Line Items
    • DISCLAIMER — Disclaimers and Clarifications
    • INCLUSION — Inclusions
    • LABOR_RATE — Labor Rates
    • MARKUP — Fees and Markups
    • SCOPE_CLARIFICATION — Scope-Specific Clarifications
    description
    string
    A description of the line item.
    section
    string
    The bid section that the line item is under. This value is null if the item is not under a section.
    isRequired
    boolean
    Indicates whether the item must be included in the bid. Possible values:
    • true: The item must be included.
    • false: The item is optional.
    isCustom
    boolean
    Indicates whether the item is a custom item added by the bidder instead of being on the bid form. Possible values:
    • true: The item was added by the bidder.
    • false: The item was on the bid form.
    unit
    enum:string
    The unit format of the bid line item.

    The possible values of this field depend on the value of the line item’s type field. Each possible line item type is listed, followed by the possible values of unit for that type:

    • ACKNOWLEDGMENT — YES_NO, TOTAL_COST_ONLY, TEXT, PERCENTAGE
    • ADDENDUM — TEXT, YES_NO, PER_ACRE, PER_AMP, PER_BOARD_FT, PER_CUBIC_FT, PER_CUBIC_METER, PER_CUBIC_YARD, PER_DAY, PER_EACH, PER_FLOOR, PER_GALLON, PER_GROSS_SQUARE_FT, PER_GROSS_SQUARE_METER, PER_HOUR, PER_KILOGRAM, PER_LINEAR_FT, PER_LINEAR_METER, PER_LINEAR_YARD, PER_LITER, PER_LOT, PER_METRIC_TON, PER_MONTH, PER_POUND, PER_RISER, PER_SQUARE_FT, PER_SQUARE_METER, PER_SQUARE_YARD, PER_SQUARE_YARD_INCH, PER_STALL, PER_STOP, PER_TON, PER_WATT, PER_WEEK, TOTAL_COST_ONLY
    • ALTERNATE — ACRES, AMPS, BOARD_FT, CUBIC_FT, CUBIC_METERS, CUBIC_YARDS, DAYS, EACH, FLOORS, GALLONS, GROSS_SQUARE_FT, HOURS, KILOGRAMS, LINEAR_FT, LINEAR_METERS, LINEAR_YARDS, LITERS, LOT, METRIC_TONS, MONTHS, POUNDS, RISERS, SQUARE_FT, SQUARE_METERS, SQUARE_YARDS, SQUARE_YARD_INCHES, STALLS, STOPS, TEXT, TONS, TOTAL_COST_ONLY, WATTS, WEEKS
    • BONDING — YES_NO, TOTAL_COST_ONLY, TEXT, PERCENTAGE
    • CERTIFICATION — TEXT, YES_NO
    • COST_BREAKDOWN — ACRES, AMPS, BOARD_FT, CUBIC_FT, CUBIC_METERS, CUBIC_YARDS, DAYS, EACH, FLOORS, GALLONS, GROSS_SQUARE_FT, GROSS_SQUARE_METERS, HOURS, KILOGRAMS, LINEAR_FT, LINEAR_METERS, LINEAR_YARDS, LITERS, LOT, METRIC_TONS, MONTHS, POUNDS, RISERS, SQUARE_FT, SQUARE_METERS, SQUARE_YARDS, SQUARE_YARD_INCHES, STALLS, STOPS, TONS, TOTAL_COST_ONLY, WATTS, WEEKS
    • DISCLAIMER — Converted to null
    • INCLUSION — YES_NO_WITH_ADJUSTMENT
    • LABOR_RATE — PER_HOUR, PER_DAY, PER_WEEK
    • MARKUP — PERCENTAGE, TOTAL_COST_ONLY
    • SCOPE_CLARIFICATION — Converted to null

    Note that the value TOTAL_COST_ONLY is used for a lump sum line item.

    code
    string
    A code associated with the line item.
    quantity
    number
    The quantity of the line item.

    Note that this field is relevant only under the following conditions (otherwise it is null):

    • The value of type is ALTERNATE or COST_BREAKDOWN.
    • The value of unit is neither TEXT nor TOTAL_COST_ONLY.
    isQuantityFixed
    boolean
    Indicates whether the line item quantity is fixed. Possible values:
    • true: The quantity is fixed, and bidders cannot change it.
    • false: The quantity can be changed by bidders.
    unitCost
    number
    The cost per unit of the line item. This is not the total cost of the line item.

    Note that this field is relevant only under the following conditions (otherwise it is null):

    • The value of type is ALTERNATE or COST_BREAKDOWN.
    • The value of unit is neither TEXT nor TOTAL_COST_ONLY.
    value
    one of
    The total value of the line item. Note the following requirements:
    • If unit is TEXT, YES_NO, or YES_NO_WITH_ADJUSTMENT, this field is a string. Otherwise, it is a number.
    • If type is SCOPE_CLARIFICATION or DISCLAIMER, this field is null.
    • If type is ALTERNATE or COST_BREAKDOWN, this field depends on the value of quantity:

      • If quantity is null, value can be set to the value that the bidder entered directly.
      • If quantity is not null, value is not relevant. The total value is calculated by multiplying quantity and unitCost.
    0
    string
    A text value, used when the line item’s unit is TEXT, YES_NO, or YES_NO_WITH_ADJUSTMENT.
    1
    number
    A numeric value, used for all other unit types.

    Example

    OK

    Request

    curl -v 'https://developer.api.autodesk.com/construction/buildingconnected/v2/bids/:bidId/line-items' \
      -H 'Authorization: Bearer AuIPTf4KYLTYGVnOHQ0cuolwCW2a'
    

    Response

    {
      "pagination": {
        "limit": 100,
        "cursorState": "eyJsaW1pdCI6MjUsIm9mZnNldCI6MjV9",
        "nextUrl": "https://developer.api.autodesk.com/construction/buildingconnected/v2/projects?cursorState=eyJsaW1pdCI6MjUsIm9mZnNldCI6MjV9"
      },
      "results": [
        {
          "id": "53811754d3a604966df72247",
          "type": "COST_BREAKDOWN",
          "description": "Duct Insulation",
          "section": "Furnish & Install",
          "isRequired": true,
          "isCustom": false,
          "unit": "HOURS",
          "code": "D2",
          "quantity": 10,
          "isQuantityFixed": true,
          "unitCost": 500,
          "value": 10000
        }
      ]
    }
    
    Show More